// BitmapButtonEx.cpp : implementation file
//

#if defined(PC_EMUL)
 #include "./Win32/stdafx.h"
#else
 #include "./WinCE/stdafx.h"
#endif

#include "BitmapButtonEx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBitmapButtonEx

CBitmapButtonEx::CBitmapButtonEx()
{
	m_p_bitmap_normal	= new CBitmap;
	m_p_bitmap_select	= new CBitmap;

	m_b_button_down		= false;

	memset( &m_rt_normal, 0, sizeof( RECT ) );
	memset( &m_rt_select, 0, sizeof( RECT ) );	

	set_option(true, false, true, true);
}

CBitmapButtonEx::~CBitmapButtonEx()
{
	m_b_button_down		= false;

	memset( &m_rt_normal, 0, sizeof( RECT ) );
	memset( &m_rt_select, 0, sizeof( RECT ) );	

	m_p_bitmap_normal->Detach();
	m_p_bitmap_select->Detach();

	delete m_p_bitmap_normal;
	delete m_p_bitmap_select;
}


BEGIN_MESSAGE_MAP(CBitmapButtonEx, CMoveWnd)
	//{{AFX_MSG_MAP(CBitmapButtonEx)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CBitmapButtonEx message handlers

void CBitmapButtonEx::OnPaint() 
{	
	RECT		rt				= {0, 0, 0, 0};
	CBitmap*	p_old_bitmap	= NULL;

	CDC			dc_mem;
	CPaintDC	dc(this); // device context for painting

	dc_mem.CreateCompatibleDC( &dc );
	p_old_bitmap = (CBitmap*)dc_mem.SelectObject( m_p_bitmap_normal );
	
	GetClientRect( &rt );
	if( m_b_button_down )
	{
		dc.StretchBlt(	rt.left, 
						rt.top, 
						rt.right - rt.left,
						rt.bottom - rt.top,
						&dc_mem, 
						m_rt_select.left, 
						m_rt_select.top, 
						m_rt_select.right, 
						m_rt_select.bottom,
						SRCCOPY	);
	}
	else
	{	
		dc.StretchBlt(	rt.left, 
						rt.top, 
						rt.right - rt.left,
						rt.bottom - rt.top,
						&dc_mem, 
						m_rt_normal.left, 
						m_rt_normal.top, 
						m_rt_normal.right, 
						m_rt_normal.bottom,
						SRCCOPY	);
	}


	dc_mem.SelectObject( p_old_bitmap );
	dc_mem.DeleteDC();
	
	// TODO: Add your message handler code here
	
	// Do not call CMoveWnd::OnPaint() for painting messages
}

void CBitmapButtonEx::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	m_b_button_down = TRUE;

	SetCapture();
	InvalidateRect(NULL, FALSE);
	
	CMoveWnd::OnLButtonDown(nFlags, point);
}

void CBitmapButtonEx::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	WORD	w_low			= 0;
	WORD	w_high			= 0;
	CWnd*	p_wnd_parent	= NULL;

	ReleaseCapture();
	
	m_b_button_down = FALSE;
	InvalidateRect(NULL, FALSE);

	// Click Notify to parent
	p_wnd_parent = GetParent();
	
	w_high	= (WORD)BN_CLICKED;
	w_low	= (WORD)GetDlgCtrlID();
	
	p_wnd_parent->SendMessage(	WM_COMMAND, 
								(WPARAM)MAKELONG(w_low, w_high), 
								(LPARAM)GetDlgCtrlID()	);
	
	CMoveWnd::OnLButtonUp(nFlags, point);
}

BOOL CBitmapButtonEx::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW, 
									   NULL, 
									   (HBRUSH)::GetStockObject(GRAY_BRUSH), 
									   NULL);
	
	return CMoveWnd::PreCreateWindow(cs);
}

BOOL CBitmapButtonEx::Create(const RECT& rect, CWnd* pParentWnd, UINT nID)
{
	// TODO: Add your specialized code here and/or call the base class
	return CWnd::Create(NULL, NULL, WS_CHILD | WS_VISIBLE, rect, pParentWnd, nID, NULL);
}

BOOL CBitmapButtonEx::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	CWnd* p_wnd_parent = GetParent();
	p_wnd_parent->SendMessage(WM_COMMAND, wParam, lParam);
	
	return CMoveWnd::OnCommand(wParam, lParam);
}


BOOL
CBitmapButtonEx::load_bitmap_normal	(
	HBITMAP		h_bitmap, 
	RECT&		rt	)
{
	if( h_bitmap )
		return FALSE;

	if( m_p_bitmap_normal->Attach( h_bitmap ) == FALSE )
		return FALSE;
	
	m_rt_normal = rt;
	return TRUE;
}

BOOL
CBitmapButtonEx::load_bitmap_select	(
	HBITMAP		h_bitmap, 
	RECT&		rt	)
{
	if( h_bitmap )
		return FALSE;

	if( m_p_bitmap_select->Attach( h_bitmap ) == FALSE )
		return FALSE;
	
	m_rt_select = rt;
	return TRUE;
}
