// MoveWnd.cpp : implementation file
//

#if defined(PC_EMUL)
 #include "./Win32/stdafx.h"
 #include "./Win32/winampaq.h"
#else
 #include "./WinCE/stdafx.h"
 #include "./WinCE/winampaq.h"
#endif

#include "MoveWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMoveWnd

CMoveWnd::CMoveWnd(	bool b_draw_focus_line,
					bool b_move_in_parent,
					bool b_vertical_move_lock,
					bool b_horizonal_move_lock	)
{
	m_b_draw_focus_line		= b_draw_focus_line;
	m_b_move_in_parent		= b_move_in_parent;
	m_b_vertical_move_lock	= b_vertical_move_lock;
	m_b_horizonal_move_lock = b_horizonal_move_lock;

	m_b_top_most			= false;	
	m_b_clicked				= false;
	memset( &m_rt_pos,		0,	sizeof( RECT ) );
	memset( &m_pt_old_pos,	0,	sizeof( RECT ) );
}

CMoveWnd::~CMoveWnd()
{
	m_b_draw_focus_line		= false;
	m_b_move_in_parent		= false;
	m_b_vertical_move_lock	= false;
	m_b_horizonal_move_lock = false;

	m_b_top_most			= false;	
	m_b_clicked				= false;
	memset( &m_rt_pos,		0,	sizeof( RECT ) );
	memset( &m_pt_old_pos,	0,	sizeof( RECT ) );
}


BEGIN_MESSAGE_MAP(CMoveWnd, CWnd)
	//{{AFX_MSG_MAP(CMoveWnd)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMoveWnd message handlers

BOOL CMoveWnd::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	cs.lpszClass = AfxRegisterWndClass(CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW,
									   NULL, 
									   (HBRUSH)::GetStockObject(NULL_BRUSH),
									   NULL);

	return CWnd::PreCreateWindow(cs);
}

void CMoveWnd::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	//	SetCapture();

	CWnd* p_wnd_parent	= NULL;

	RECT rt_client		= {0, 0, 0, 0};
	RECT rt_parent		= {0, 0, 0, 0};
	RECT rt_my			= {0, 0, 0, 0};	

	m_b_clicked = true;

	if( m_b_draw_focus_line )
	{
		GetWindowRect( &rt_client );
		m_rt_pos = rt_client;

		m_pt_old_pos = point;
	}
	else
	{
		//////////////////////////////////////////////////////////////////////////
		// for move
		//////////////////////////////////////////////////////////////////////////
		
		// save current position
		
		p_wnd_parent = GetParent();
		if( p_wnd_parent == NULL )
		{
			rt_parent.left		= 0;
			rt_parent.top		= 0;
			rt_parent.right		= GetSystemMetrics( SM_CXSCREEN );
			rt_parent.bottom	= GetSystemMetrics( SM_CYSCREEN );
		}
		else
		{
			p_wnd_parent->GetWindowRect( &rt_parent );
		}
		
		
		GetWindowRect( &rt_my );
		m_rt_pos.left	= rt_my.left	- rt_parent.left;
		m_rt_pos.top	= rt_my.top		- rt_parent.top;
		m_rt_pos.right	= rt_my.right	- rt_parent.left;
		m_rt_pos.bottom = rt_my.bottom	- rt_parent.top;
			
		// save current point
		m_pt_old_pos = point;
		ClientToScreen( &m_pt_old_pos );

		//////////////////////////////////////////////////////////////////////////	
	}

//	SendMessage(UM_WINDOWPOSCHANGESTART);

//	CWnd::OnLButtonDown(nFlags, point);
}

void CMoveWnd::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

	LONG	l_style			= 0L;
	RECT	rt_parent		= {0, 0, 0, 0};
	CWnd*	p_wnd_parent	= NULL;

	if( m_b_clicked == FALSE )
	{
		m_b_clicked = false;
		return;
	}

	//////////////////////////////////////////////////////////////////////////
	// for move
	if( m_b_draw_focus_line )
	{		
		p_wnd_parent	= GetParent();
		l_style			= GetWindowLong( GetSafeHwnd(), GWL_STYLE );

		if( ( p_wnd_parent == NULL )		|| 
			( l_style & WS_POPUP )	)
		{
			rt_parent.left		= 0;
			rt_parent.top		= 0;
			rt_parent.right		= GetSystemMetrics( SM_CXSCREEN );
			rt_parent.bottom	= GetSystemMetrics( SM_CYSCREEN );
		}
		else
		{
			p_wnd_parent->GetWindowRect( &rt_parent );
		}
	
		m_rt_pos.left	-= rt_parent.left;
		m_rt_pos.top	-= rt_parent.top;
		m_rt_pos.right	-= rt_parent.left;
		m_rt_pos.bottom	-= rt_parent.top;
		
		MoveWindow( &m_rt_pos, true );
	}
	else
	{
		MoveWindow( &m_rt_pos, false );
	}
		
	m_b_clicked = false;
	
//	SendMessage( UM_WINDOWPOSCHANGED );
	
	//////////////////////////////////////////////////////////////////////////
	
//	CWnd::OnLButtonUp(nFlags, point);
}

void CMoveWnd::OnMouseMove(UINT nFlags, CPoint point) 
{
	int		n_x_gap			= 0;
	int		n_y_gap			= 0;

	RECT	rt_my			= {0, 0, 0, 0};
	RECT	rt_parent		= {0, 0, 0, 0};
	RECT	rt_move			= {0, 0, 0, 0};
	RECT	rt_msg			= {0, 0, 0, 0};

	POINT	pt				= {0, 0};

	CWnd*	p_wnd_parent	= NULL;
	
	CClientDC dc( GetDesktopWindow() );
	
	
	if( m_b_clicked == FALSE )
		return;
	
	p_wnd_parent	= GetParent();

	if( m_b_draw_focus_line )
	{
		dc.DrawFocusRect( &m_rt_pos );

		n_x_gap = point.x - m_pt_old_pos.x;
		n_y_gap = point.y - m_pt_old_pos.y;

		m_pt_old_pos = point;

		if( m_b_vertical_move_lock == FALSE )
		{
			m_rt_pos.top	+= n_y_gap;
			m_rt_pos.bottom += n_y_gap;
		}
		
		if( m_b_horizonal_move_lock == FALSE )
		{
			m_rt_pos.left	+= n_x_gap;
			m_rt_pos.right	+= n_x_gap;
		}

		dc.DrawFocusRect( &m_rt_pos );
	}
	else
	{
		//////////////////////////////////////////////////////////////////////////
		// get parent position
		//////////////////////////////////////////////////////////////////////////
				
		if( p_wnd_parent == NULL )
		{
			rt_parent.left		= 0;
			rt_parent.top		= 0;
			rt_parent.right		= GetSystemMetrics( SM_CXSCREEN );
			rt_parent.bottom	= GetSystemMetrics( SM_CYSCREEN );
		}
		else
		{
			p_wnd_parent->GetWindowRect( &rt_parent );
		}

		//////////////////////////////////////////////////////////////////////////
		


		//////////////////////////////////////////////////////////////////////////
		// calculate move position
		//////////////////////////////////////////////////////////////////////////
				
		GetWindowRect( &rt_my );
		
		rt_move.left	= rt_my.left	- rt_parent.left;
		rt_move.top		= rt_my.top		- rt_parent.top;
		rt_move.right	= rt_my.right	- rt_parent.left;
		rt_move.bottom	= rt_my.bottom	- rt_parent.top;

		pt = point;
		ClientToScreen(&pt);

		n_x_gap = pt.x - m_pt_old_pos.x;
		n_y_gap = pt.y - m_pt_old_pos.y;
		
		//////////////////////////////////////////////////////////////////////////
		


		//////////////////////////////////////////////////////////////////////////
		// exception
		if( m_b_move_in_parent )
		{
			if( rt_my.left < rt_parent.left )
			{
				rt_move.left	= 0;
				rt_move.right	= rt_my.right - rt_my.left;
			}
			else if( rt_my.right > rt_parent.right )
			{
				rt_move.right	= rt_parent.right - rt_parent.left;
				rt_move.left	= rt_move.right - ( rt_my.right - rt_my.left );
			}
			else
			{
				;
			}

			if( rt_my.top < rt_parent.top )
			{
				rt_move.top		= 0;
				rt_move.bottom	= rt_my.bottom = rt_my.top;
			}
			else if( rt_my.bottom > rt_parent.bottom )
			{
				rt_move.bottom	= rt_parent.bottom - rt_parent.top;
				rt_move.top		= rt_move.bottom - ( rt_my.bottom - rt_my.top );
			}
		}

		if(!m_b_vertical_move_lock)
		{
			rt_move.top		+= n_y_gap;
			rt_move.bottom	+= n_y_gap;
		}
		
		if(!m_b_horizonal_move_lock)
		{
			rt_move.left	+= n_x_gap;
			rt_move.right	+= n_x_gap;
		}
		//////////////////////////////////////////////////////////////////////////
		


		//////////////////////////////////////////////////////////////////////////
		// move & position save
		this->MoveWindow( &rt_move );
		
		m_pt_old_pos = pt;
		m_rt_pos = rt_move;
		//////////////////////////////////////////////////////////////////////////
	}
	
	// send message to parent
	p_wnd_parent = GetParent();
	this->GetWindowRect( &rt_msg );
//	p_wnd_parent->SendMessage( UM_MOUSEMOVE, (WPARAM)&rt_msg );
}



BOOL
CMoveWnd::set_option	(
	bool b_draw_focus_line, 
	bool b_move_in_parent, 
	bool b_vertical_move_lock, 
	bool b_horizonal_move_lock	)
{
	m_b_draw_focus_line		= b_draw_focus_line;
	m_b_move_in_parent		= b_move_in_parent;
	m_b_vertical_move_lock	= b_vertical_move_lock;
	m_b_horizonal_move_lock = b_horizonal_move_lock;

	return TRUE;
}

BOOL
CMoveWnd::draw_focus_line	(
	bool b_draw	)
{
	m_b_draw_focus_line = b_draw;

	return TRUE;
}

BOOL
CMoveWnd::move_in_parent	(
	bool b_move_in_parent	)
{
	m_b_move_in_parent = b_move_in_parent;

	return TRUE;
}

BOOL
CMoveWnd::vertical_move_lock	(
	bool b_block	)
{
	m_b_vertical_move_lock = b_block;

	return TRUE;
}

BOOL
CMoveWnd::horizonal_move_lock	(
	bool b_lock	)
{
	m_b_horizonal_move_lock = b_lock;

	return TRUE;
}

BOOL
CMoveWnd::set_top_most	(
	BOOL b_true	)
{
	RECT rt		= {0, 0, 0, 0};
	BOOL b_ret	= FALSE;
	
	GetWindowRect( &rt );

	if( b_true )
	{
		b_ret = SetWindowPos(	&CWnd::wndTopMost, 
								rt.left, 
								rt.top, 
								rt.right - rt.left,
								rt.bottom - rt.top,
								NULL	);
	}
	else
	{
		b_ret = SetWindowPos(	&CWnd::wndNoTopMost,
								rt.left, 
								rt.top, 
								rt.right - rt.left,
								rt.bottom - rt.top,
								NULL	);
	}	

	if(b_ret)
	{
		m_b_top_most = b_true;
		return TRUE;
	}

	return FALSE;
}

BOOL
CMoveWnd::is_top_most	( )
{
	return m_b_top_most;
}

